pro patch_img_define_event, event

COMMON image, img, header, N, M, a_dim, Nori, Mori
common img_define, param, orig, N_ori, M_ori

WIDGET_CONTROL, event.id, GET_UVALUE=uvalue
WIDGET_CONTROL, event.top, GET_UVALUE=id
case uvalue of
'dom_type' : if (event.value EQ 1 ) then begin
                widget_control, id.domx, SENSITIVE=0
                widget_control, id.domy, SENSITIVE=0
                widget_control, id.rows, /SENSITIVE
                widget_control, id.cols, /SENSITIVE
             endif else begin
                widget_control, id.domx, /SENSITIVE
                widget_control, id.domy, /SENSITIVE
                widget_control, id.rows, SENSITIVE=0
                widget_control, id.cols, SENSITIVE=0
             endelse

'rows' : begin
   if (M mod event.value NE 0) then begin
       a=dialog_message(["The chosen number of rows does not fit the image size,", $
                        "do you want to apply a zero-padding around the image?"], $
                        title="QUESTION", /QUESTION, /DEFAULT_NO, $
                        dialog_parent=event.top)
       if (a EQ 'Yes') then begin
          param.rows=event.value
          new_dim = ceil(double(M) / double(param.rows)) * param.rows
          ok=dialog_message(["Previous size = "+strtrim(N,1)+" x "+strtrim(M,1), $
                             "New size = "+strtrim(N,1)+" x "+strtrim(new_dim,1)], $
                             dialog_parent=event.top)          
          M=new_dim
          param.domy = fix(M/param.rows)
          widget_control, id.domy, set_value=strtrim(param.domy,1)
       endif else begin
          ;reset the "rows" value
          widget_control, id.rows, set_value=strtrim(param.rows,1)
       endelse
   endif else begin
       param.rows=event.value
       param.domy = fix(M/param.rows)
       widget_control, id.domy, set_value=strtrim(param.domy,1)
   endelse
   end
'cols' : begin
   if (N mod event.value NE 0) then begin
       a=dialog_message(["The chosen number of columns does not fit the image size,", $
                        "do you want to apply a zero-padding around the image?"], $
                        title="QUESTION", /QUESTION, /DEFAULT_NO, $
                        dialog_parent=event.top)
       if (a EQ 'Yes') then begin
          param.cols=event.value
          new_dim = ceil(double(N)/ double(param.cols)) * param.cols
          ok=dialog_message(["Previous size = "+strtrim(N,1)+" x "+strtrim(M,1), $
                             "New size = "+strtrim(new_dim,1)+" x "+strtrim(M,1)], $
                             dialog_parent=event.top)          
          N=new_dim
          param.domx = fix(N/param.cols)
          widget_control, id.domx, set_value=strtrim(param.domx,1)
       endif else begin
          ;reset the "cols" value
          widget_control, id.cols, set_value=strtrim(param.cols,1)
       endelse
   endif else begin
       param.cols=event.value
       param.domx = fix(N/param.cols)
       widget_control, id.domx, set_value=strtrim(param.domx,1)
   endelse
   end
;'overlap' : param.overlap=event.value 
'reset': begin
         N=N_ori
         M=M_ori
         param.domx=orig.domx
         param.domy=orig.domy
         param.rows=orig.rows
         param.cols=orig.cols
         ;param.overlap=orig.overlap
         widget_control, id.rows, set_value=param.rows
         widget_control, id.cols, set_value=param.cols
         widget_control, id.domx, set_value=strtrim(param.domx,1)
         widget_control, id.domy, set_value=strtrim(param.domy,1)
         end        
'ok'   : begin
         WIDGET_CONTROL, event.top, /DESTROY
         end
endcase

end


;;;;;;;;;;;;;;;;;;;;;;;;;
; GUI generation code
;;;;;;;;;;;;;;;;;;;;;;;;;
function patch_img_define, title, state, GROUP_LEADER=group

common image, img, header, N, M
common img_define, param, orig, N_ori, M_ori

;copy initial params in order to reset the GUI values
param=state.par
orig=state.par
N_ori=N
M_ori=M

;param is the structure (of the parameters) containing edited/modified values
;orig is the structure containing original values

id = { root_base_id0: 0L, rows:0L, cols:0L, domx:0L, domy:0L, overlap:0L }

modal = n_elements(group) ne 0
root_base_id0 = widget_base(TITLE=title,/COL,MODAL=modal, GROUP_LEADER=group)
base = widget_base(root_base_id0, /FRAME,/COL)
label=WIDGET_LABEL(base, value="Enter the number of sub-domains (and PSFs)")
label=WIDGET_LABEL(base, value="in the form of 2D matrix (rows x columns) ")
label=WIDGET_LABEL(base, value=" -- press ENTER after setting each value -- ")
base2=WIDGET_BASE(base, /ROW, /ALIGN_CENTER)
id.rows=CW_FIELD(base2, title="", value=param.rows, /INTEGER, uvalue="rows", $
                 /RETURN_EVENTS, xsize=5 ) 
label=WIDGET_LABEL(base2, value = "   x   ")       
id.cols=CW_FIELD(base2, title="", value=param.cols, /INTEGER, uvalue="cols", $
                 /RETURN_EVENTS, xsize=5 )  
label=WIDGET_LABEL(base, value="Resulting size of each sub-domain:")
base3=WIDGET_BASE(base, /ROW, /ALIGN_CENTER)
id.domx=WIDGET_TEXT(base3, value=strtrim(param.domx,1))        
label=WIDGET_LABEL(base3, value = "   x   ")       
id.domy=WIDGET_TEXT(base3, value=strtrim(param.domy,1))  
;label=WIDGET_LABEL(base, value="  ---  ")                 
;id.overlap=CW_FIELD(base, title="Overlapping region (pixels):", $
;           /INTEGER, uvalue="overlap", /RETURN_EVENTS, value=param.overlap)      
; standard buttons base
btn_base_id = widget_base(root_base_id0,/FRAME,/ROW, /ALIGN_RIGHT)
reset_id = widget_button(btn_base_id, VALUE="Reset to default settings", UVALUE="reset" )
ok_id = widget_button(btn_base_id, VALUE=" Save and close ", UVALUE="ok" )



WIDGET_CONTROL, root_base_id0, SET_UVALUE=id
WIDGET_CONTROL, root_base_id0, /REALIZE

xmanager, 'patch_img_define', root_base_id0, /NO_BLOCK, GROUP_LEADER=group
return, param
end
