pro patch_img_options_event, event

;COMMON image, img, header, N, M
common img_options, param;, orig, N_ori, M_ori

WIDGET_CONTROL, event.id, GET_UVALUE=uvalue
WIDGET_CONTROL, event.top, GET_UVALUE=id
case uvalue of
'zoom': param.img_zoom=event.value
'z1': begin
      param.img_zoom=0.25
      widget_control, id.zoom, set_value=param.img_zoom
      end
'z2': begin
      param.img_zoom=0.5
      widget_control, id.zoom, set_value=param.img_zoom
      end
'z3': begin
      param.img_zoom=1.
      widget_control, id.zoom, set_value=param.img_zoom
      end
'z4': begin
      param.img_zoom=2.
      widget_control, id.zoom, set_value=param.img_zoom
      end
'z5': begin
      param.img_zoom=4.
      widget_control, id.zoom, set_value=param.img_zoom
      end
'scale':param.img_scale=event.index 
'color':param.img_color=event.index
'ok'   : begin
         WIDGET_CONTROL, event.top, /DESTROY
         end
endcase
;
end


;;;;;;;;;;;;;;;;;;;;;;;;;
; GUI generation code
;;;;;;;;;;;;;;;;;;;;;;;;;
function patch_img_options, title, state, GROUP_LEADER=group

;common image, img, header, N, M
common img_options, param;, orig, N_ori, M_ori

;copy initial params in order to reset the GUI values
param=state.par
;orig=state.par
;N_ori=N
;M_ori=M

;param is the structure (of the parameters) containing edited/modified values
;orig is the structure containing original values

id = { root_base_id0: 0L, zoom:0L, scale:0L, color:0L }

;modal = n_elements(group) ne 0
root_base_id0 = widget_base(TITLE=title,/COL, /modal, GROUP_LEADER=group)
base = widget_base(root_base_id0, /FRAME,/COL)
id.zoom=CW_FIELD(base, title="Zoom [ENTER]: ", value=param.img_zoom, /FLOATING, uvalue="zoom", $
                 /RETURN_EVENTS, xsize=10 ) 
base1 =widget_base(base, /ROW)
button1=WIDGET_BUTTON(base1, value='0.25 x', xsize=50, uvalue="z1")
button2=WIDGET_BUTTON(base1, value='0.5 x ', xsize=50, uvalue="z2")
button3=WIDGET_BUTTON(base1, value='  1 x ', xsize=50, uvalue="z3")
button4=WIDGET_BUTTON(base1, value='  2 x ', xsize=50, uvalue="z4")
button5=WIDGET_BUTTON(base1, value='  4 x ', xsize=50, uvalue="z5")

scale_str=['Linear', 'Log', 'Square', 'Sqrt', 'Gamma (0.2)', 'Gamma (0.1)']
label=WIDGET_LABEL(base, value="Scale : ")
id.scale=WIDGET_COMBOBOX(base, value=scale_str, uvalue='scale')

loadct, GET_NAMES=color_str, /SILENT
label=WIDGET_LABEL(base, value="Color : ")
id.color=WIDGET_COMBOBOX(base, value=color_str, uvalue='color')


; standard buttons base
btn_base_id = widget_base(root_base_id0,/FRAME,/ROW, /ALIGN_RIGHT)
ok_id = widget_button(btn_base_id,  VALUE=" Apply and close ", UVALUE="ok")



WIDGET_CONTROL, root_base_id0, SET_UVALUE=id
WIDGET_CONTROL, root_base_id0, /REALIZE
WIDGET_CONTROL, id.scale, set_combobox_select=param.img_scale
WIDGET_CONTROL, id.color, set_combobox_select=param.img_color
xmanager, 'patch_img_options', root_base_id0, /NO_BLOCK, GROUP_LEADER=group
return, param
end
